

module trevisor(WE, CS0, CS1, OE, IRQ, RESET, LOWBAT, A, D, IO);

	input WE, CS0, CS1, OE, RESET, LOWBAT;
	input [3:0]A;
	inout [7:0]D;
	output IRQ;
	inout [7:0]IO;

	reg trevaclock;
	reg trevadata;

	wire active = RESET & LOWBAT;
	wire chipselect = CS0;
	wire writecycle = ~OE | chipselect | WE;
	wire readcycle = ~OE & ~chipselect & WE;

	assign IRQ = 1;
	assign IO = active ? { 6'bZZZZZZ, trevaclock, 1'bZ } : 8'bZZ;
	assign D = readcycle ? { 7'b1111111, trevadata } : 8'bZZ;

	always @ (posedge writecycle) begin
		if (D[0]) trevadata <= IO[0];
		trevaclock <= D[0];
	end

endmodule




